﻿@page "/employeeviewreservations"
@using Microsoft.EntityFrameworkCore
@using Microsoft.AspNetCore.Authorization
@using HotelData.DatabaseAccess
@using HotelAppServerSide.Data;
@inject IDbContextFactory<HotelDataContext> HotelDataContextFactory
@inject HotelDataService DataService
@attribute [StreamRendering, Authorize]
@rendermode InteractiveServer

<PageTitle>View All Reservations</PageTitle>

<MudContainer Class="mt-4">
    <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")">
        <MudGrid Spacing="0" Justify="Justify.Center">
            <MudItem xs="6" Class="d-flex align-center justify-center mud-width-full">
                <MudButton 
                    Class="align-content-center"
                    Variant="Variant.Filled" 
                    Color="Color.Primary" 
                    OnClick="OnCurrentReservationsClicked">View Current/Upcoming Reservations</MudButton>
            </MudItem>

            <MudItem xs="6" Class="d-flex align-center justify-center mud-width-full">
                <MudButton 
                    Variant="Variant.Filled" 
                    Color="Color.Primary" 
                    OnClick="OnAllReservationsClicked">View All Reservations</MudButton>
            </MudItem>

        </MudGrid>
    </MudPaper>
    
</MudContainer>

@*Table for presenting immediately relevant hotel room data*@
@if (ShowCurrentReservations)
{
    <MudItem Class="mt-2">
        <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
            <MudText Typo="Typo.h6">Ongoing/Upcoming Reservations</MudText>

            <MudItem Class="mt-2">
                <MudTable Items="@DataService.HotelRooms"
                          Hover="true"
                          Breakpoint="Breakpoint.Sm"
                          LoadingProgressColor="Color.Info"
                          Style="@($"background:{Colors.Purple.Lighten5};")"
                          Height="70vh">
                    <ColGroup>
                        <col style="width:50px;" />
                        <col style="width:50px;" />
                        <col style="width:50px;" />
                        <col />
                        <col style="width:200px;" />
                    </ColGroup>
                    <HeaderContent>
                        <MudTh>Room</MudTh>
                        <MudTh>Bed Count</MudTh>
                        <MudTh>Daily Cost</MudTh>
                        <MudTh>Vacancy Status</MudTh>
                        <MudTh></MudTh>
                    </HeaderContent>
                    <RowTemplate>
                        <MudTd>@context.RoomNumber</MudTd>
                        <MudTd>@context.BedCount</MudTd>
                        <MudTd>@context.DayCost</MudTd>
                        <MudTd>@CheckVacancy(context)</MudTd>
                        <MudTd>
                            <MudButton Variant="Variant.Outlined"
                                       Size="Size.Small"
                                       OnClick="@(() => MoreDetailsPressed(context))">
                                @((context.ShowDetails) ? "Hide" : "Show")
                            </MudButton>
                        </MudTd>
                    </RowTemplate>


                    @* Give all table elements expandable children that let employees read more about current/immediate upcoming vacancies *@
                    <ChildRowContent>
                        @if (context.ShowDetails)
                        {
                            <MudTr>
                                <td colspan="5">
                                    @* Card for displaying any current reservation in this room *@
                                    <MudCard Elevation="3" Style="@($"background:{Colors.Purple.Lighten5};")">
                                        <MudCardContent Class="pa-4">

                                            <MudText Typo="Typo.h6">@(context.RoomNumber) - Current Reservation</MudText>

                                            <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                                                @if (context?.OngoingReservation?.PersonID == null)
                                                {
                                                    <MudText Typo="Typo.body1">This room is currently free.</MudText>
                                                }
                                                else
                                                {
                                                    <MudGrid Spacing="2" Class="align-items-center">
                                                        <MudItem xs="3">
                                                            <MudText Typo="Typo.body1">
                                                                Name - 
                                                                @(DataService.Clients[context.OngoingReservation.PersonID].FirstName)
                                                                @(DataService.Clients[context.OngoingReservation.PersonID].LastName)
                                                            </MudText>
                                                        </MudItem>

                                                        <MudItem xs="3">
                                                            <MudText Typo="Typo.body1">
                                                                Person ID - @(context.OngoingReservation.PersonID)
                                                            </MudText>
                                                        </MudItem>

                                                        <MudItem xs="3">
                                                            <MudText Typo="Typo.body1">
                                                                Email - @(DataService.Clients[context.OngoingReservation.PersonID].Email)
                                                            </MudText>
                                                        </MudItem>

                                                        <MudItem xs="3">
                                                            <MudText Typo="Typo.body1">
                                                                End Date - @(context.OngoingReservation.GetEndDateString())
                                                            </MudText>
                                                        </MudItem>

                                                    </MudGrid>
                                                }
                                            </MudPaper>
                                        </MudCardContent>
                                    </MudCard>

                                    @* Card for displaying upcoming reservations in this room *@
                                    <MudCard Class="mt-2" Elevation="3" Style="@($"background:{Colors.Purple.Lighten5};")">
                                        <MudCardContent Class="pa-4">
                                            <MudText Typo="Typo.h6">@(context.RoomNumber) - Upcoming Reservations</MudText>

                                            <MudPaper Class="pa-4 rounded-lg" Style="@($"background:{Colors.DeepPurple.Lighten5};")" Elevation="3">
                                                @if (context?.UpcomingReservations.Count == 0)
                                                {
                                                    <MudText Typo="Typo.body1">No upcoming reservations.</MudText>
                                                }
                                                else
                                                {
                                                    <MudTable Items="@context?.UpcomingReservations"
                                                              Context="upcoming"
                                                              Hover="true"
                                                              Breakpoint="Breakpoint.Sm"
                                                              Elevation="0"
                                                              Virtualize="true"
                                                              Style="@($"background:{Colors.DeepPurple.Lighten5};")"
                                                              Height="40vx">
                                                        <ColGroup>
                                                            <col />
                                                            <col />
                                                            <col />
                                                            <col />
                                                            <col />
                                                        </ColGroup>

                                                        <HeaderContent>
                                                            <MudTh>Name</MudTh>
                                                            <MudTh>Person ID</MudTh>
                                                            <MudTh>Email</MudTh>
                                                            <MudTh>Start Date</MudTh>
                                                            <MudTh>End Date</MudTh>
                                                        </HeaderContent>

                                                        <RowTemplate>
                                                            <MudTd>@(DataService.Clients[upcoming.PersonID ?? ""]?.FirstName) @(DataService.Clients[upcoming.PersonID ?? ""]?.LastName)</MudTd>
                                                            <MudTd>@upcoming.PersonID</MudTd>
                                                            <MudTd>@(DataService.Clients[upcoming.PersonID ?? ""]?.Email)</MudTd>
                                                            <MudTd>@upcoming.GetStartDateString()</MudTd>
                                                            <MudTd>@upcoming.GetEndDateString()</MudTd>
                                                        </RowTemplate>
                                                    </MudTable>
                                                }
                                            </MudPaper>
                                        </MudCardContent>
                                    </MudCard>
                                </td>
                            </MudTr>
                        }
                    </ChildRowContent>
                </MudTable>
            </MudItem>
        </MudPaper>
    </MudItem>
}


@*Second table, for actually showing all reservation data*@
@if (ShowAllReservations)
{
    <MudItem Class="mt-2">
        <MudTable Items="@DataService.ClientReservations.OrderByDescending(t => t.StartDate)"
                    Virtualize="true"
                    Dense="true"
                    Height="70vh"
                    Style="@($"background:{Colors.Purple.Lighten5};")"
                    Filter="new Func<Reservation,bool>(FilterFunc1)">
            <ToolBarContent>
                <MudText Typo="Typo.h6">All Reservations</MudText>
                <MudSpacer />
                <MudTextField @bind-Value="searchString1" Placeholder="Search" Adornment="Adornment.Start" AdornmentIcon="@Icons.Material.Filled.Search" IconSize="Size.Medium" Class="mt-0"></MudTextField>
            </ToolBarContent>
            <ColGroup>
                <col style="width:50px;" />
                <col style="width:20px;" />
                <col />
                <col />
                <col />
                <col />
                <col />
                <col style="width:50px;" />
            </ColGroup>
            <HeaderContent>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>x.RoomName)">Room</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>GetBedCount(x.RoomName))">Bed Count</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>GetClientFullName(x.PersonID))">Name</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>x.PersonID)">Person ID</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>GetClientEmail(x.PersonID))">Email</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>GetReservationStatus(x))">Status</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>x.GetStartDateString())">Start Date</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>x.GetEndDateString())">End Date</MudTableSortLabel></MudTh>
                <MudTh><MudTableSortLabel SortBy="new Func<Reservation, object>(x=>GetCost(x))">Visit Price</MudTableSortLabel></MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTh>@context.RoomName</MudTh>
                <MudTh>@GetBedCount(context.RoomName)</MudTh>
                <MudTh>@GetClientFullName(context.PersonID)</MudTh>
                <MudTh>@context.PersonID</MudTh>
                <MudTh>@GetClientEmail(context.PersonID)</MudTh>
                <MudTh>@GetReservationStatus(context)</MudTh>
                <MudTh>@context.GetStartDateString()</MudTh>
                <MudTh>@context.GetEndDateString()</MudTh>
                <MudTh>@GetCost(context) €</MudTh>
            </RowTemplate>
        </MudTable>

    </MudItem>
}


    


